//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++ Library zum Testen der an die DDE-Funktionen uebergebenen Argumente

#include <windows.h>
#include <string.h>		//fuer strcmp()

#define szBufSize 50

#define DLLMEX
#include "..\header\mex.h"

#pragma hdrstop


//Prototypes
BOOL mxIsScalar( Matrix* pm );


//wird hier nur intern benutzt
BOOL mxIsScalar( Matrix* pm )
{
	if ( (mxGetM(pm) == 1) && (mxGetN(pm) == 1) )
		return TRUE;
	else return FALSE;

}




//fuer ddeinit.dll
BOOL TestServiceArg( Matrix* service )
{
	if ( !mxIsString(service) || mxGetM(service) > 1 )
	{
		mexPrintf( "???  The service argument must be a one row string.\r\n" );
		MessageBeep( (UINT)-1 );

		return FALSE;
	}
	return TRUE;
}

//fuer ddeinit.dll
BOOL TestTopicArg( Matrix* topic )
{
	if ( !mxIsString(topic) || mxGetM(topic) > 1 )
	{
		mexPrintf( "???  The topic argument must be a one row string.\r\n" );
		MessageBeep( (UINT)-1 );

		return FALSE;
	}
	return TRUE;
}


//fuer ddepoke.dll
BOOL TestMatrixArg( Matrix* matx )
{
	if ( mxIsString(matx) )
	{
		mexPrintf( "???  The matrix argument must be numeric.\r\n" );
		MessageBeep( (UINT)-1 );

		return FALSE;
	}
	return TRUE;
}

//fuer ddeadv.dll
BOOL TestCallbackArg( Matrix* callback )
{
	if ( !mxIsString(callback) || mxGetM(callback) != 1 )
	{
		mexPrintf( "???  The callback argument must be a one row string.\r\n" );
		MessageBeep( (UINT)-1 );

		return FALSE;
	}
	return TRUE;
}

//fuer ddeadv.dll
char* TestUpmtxArg( Matrix* upmtx )
{
	if ( !mxIsString( upmtx ) || (int)mxGetM( upmtx ) != 1)
	{
		mexPrintf( "???  The upmtx argument must be a one row string.\r\n" );
		MessageBeep( (UINT)-1 );

		return (char*)-1;
	}
	else
	{
		int n;
		char* szDestMatrix = (char*) mxCalloc( n= (int)mxGetN(upmtx) + 1, sizeof(char) );
		mxGetString( upmtx, szDestMatrix, n );

		return szDestMatrix;	
	}
}


//fuer ddeexec.dll
BOOL TestCommandArg( Matrix* command)
{
    if ( !mxIsString(command) || mxGetM(command) != 1 )
	{
		mexPrintf( "???  The command argument must be a one row string.\r\n" );
		MessageBeep( (UINT)-1 );

		return FALSE;
	}

	return TRUE;
}


//fuer alle anderen dlls
BOOL TestIOArgs( int in, int minIn, int maxIn )
{
	if ( in < minIn || in > maxIn )
	{
		char* szBuffer = (char*)mxCalloc( szBufSize, sizeof(char) );

		if ( minIn == maxIn )
		{
			wsprintf( szBuffer, "???  Function requires %d input argument(s).\r\n", minIn );
			mexPrintf( szBuffer );
			MessageBeep( (UINT)-1 );

			return FALSE;
		}

		else
		{
			wsprintf( szBuffer, "???  Function requires %d to %d input arguments.\r\n", minIn, maxIn );
			mexPrintf( szBuffer );
			MessageBeep( (UINT)-1 );

			return FALSE;
		}

		mxFree( szBuffer );
	}

	return TRUE;
}


BOOL TestChannelArg( Matrix* channel )
{
	if ( mxIsString(channel) )
	{
		mexPrintf( "???  The channel argument must be a valid channel handle.\r\n" );
		MessageBeep( (UINT)-1 );

		return FALSE;
	}		

	if ( !mxIsScalar(channel) )
	{
		mexPrintf( "???  The channel argument must be a numeric scalar.\r\n" );
		MessageBeep( (UINT)-1 );

		return FALSE;
	}

	return TRUE;
}



BOOL TestItemArg( Matrix* item )
{
    if ( !mxIsString(item) || mxGetM(item) != 1 )
	{
		mexPrintf( "???  The item argument must be a one row string.\r\n" );
		MessageBeep( (UINT)-1 );

		return FALSE;
	}

	return TRUE;
}



WORD TestFormatArg( Matrix* format, BOOL *strchk )
{
	WORD	cbFormat;
	WORD	retVal;
	double	isString;


	if ( *strchk )	//Test, ob Stringmatrix
	{
	    if ( mxIsString(format) || mxGetM(format) != 1 || mxGetN(format) != 2 )
		{
			mexPrintf( "???  The clipboard format argument must be a two-element, numeric and one row matrix.\r\n" );
			MessageBeep( (UINT)-1 );

			return (WORD)-1;
		}
		
	}
	else
	{
	    if ( mxIsString(format) || mxGetM(format) != 1 )
		{
			mexPrintf( "???  The clipboard format argument must be numeric.\r\n" );
			MessageBeep( (UINT)-1 );

			return (WORD)-1;
		}
	}
		
		
	cbFormat = (WORD)mxGetScalar( format );
	
	if ( *strchk )
	{
		hmemcpy( (char*)&isString, (char huge*)mxGetPr(format) + sizeof(double)/* erste Zahl ueberspringen*/, sizeof(double) );			
		
		if ( isString < (double)0 || isString > (double)1 )
		{
			mexPrintf( "???  The 2nd format argument is not valid.\r\n" );
			MessageBeep( (UINT)-1 );

			return (WORD)-1;
		}

		if ( cbFormat != (WORD)1 && isString == (double)1 )
		{
			mexPrintf( "???  For string-resultant matrix CF_TEXT format is required.\r\n" );
			MessageBeep( (UINT)-1 );	

			return (WORD)-1;			//mit XlTable nicht mglich
		}

		if ( cbFormat == (WORD)1 && isString == (double)1 )
			return CF_TEXT;				// OK, *strchk bleibt TRUE        	

		if ( cbFormat == (WORD)1 )
		{
			*strchk = FALSE;
			return CF_TEXT;				//OK, CF_TEXT aber keine String-Matrix
		}
	}


	if ( cbFormat == (WORD)1 )
		return CF_TEXT;

	else
	{
		char* szBuffer = (char*)mxCalloc( szBufSize, sizeof(char) );

		GetClipboardFormatName( cbFormat, szBuffer, szBufSize );

		if ( strcmp (szBuffer, "XlTable") == 0 )	//[szBuffer] == "XlTable" ?
			retVal = cbFormat;

		else
		{
			mexPrintf( "???  Only XlTable and CF_TEXT format are currently supported.\r\n" );
			MessageBeep( (UINT)-1 );
			
			retVal = (WORD)-1;
		}

		mxFree( szBuffer );
		return retVal;
	}
}



DWORD TestTimeoutArg( Matrix* timeout )
{
	if ( mxIsString(timeout) || !mxIsScalar(timeout) )
	{
		mexPrintf( "???  The timeout argument must be a numeric scalar.\r\n" );
		MessageBeep( (UINT)-1 );

		return (DWORD)-1;
	}
    else
    {
		double time = mxGetScalar( timeout );
		
		if ( time <= (double)0 )
		{
			mexPrintf( "???  The timeout value must be greater then 0.\r\n" );
			MessageBeep( (UINT)-1 );

			return (DWORD)-1;
		}
		return (DWORD)time;
	}
}


